//******************************************
//           This is a C Template file
//ߣ   
//     
//
//ע
//****************************************** 
/*							Pin Assignment
*********************************************************************
.........................-----------------............................
01.VSS.................01|O              |16.VDD
02.P00/XIN.............02|               |15.P40/AIN0/KWI0
03.P01/XOUT............03|     QFN-16    |14.P41/AIN1/KWI1
04.P10/RESETB..........04|               |13.P42/AIN2/KWI2
05.P71/TC01/PWM01B.....05|               |12.P43/AIN3/KWI3/VREF
06.P90/TX/RX...........06|     LQFP-16   |11.P74/DVOB/AIN8/SI/KWI13      
07.P91/RX/TX...........07|               |10.P76/INT3/SCLK/KWI15
08.P72/TCA0/PPGA0B.....08|	             |9.P70/TC00/PWM00B               
.........................-----------------............................
*********************************************************************/
//******************************************
//Stack Pointer	=	0x23f (If use mq6821_x_startup.asm)
//Ram range = 0x40~0x23f
//******************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif  
#include "MQ6821.h"
#include "MQ6812_REG_BIT.h"
#include "iApp.h"
#include "OPmode.h"
#include "KWU.h"
#include "ExtINT.h"

//-- ض庯 --//


//-- 庯 --//


//-- ȫֱ --//


//-- ȫֳ --//


//-- ȫֱ --//




void main()
{
//----------------------------------------------------------------------//
//****** IO, CGCR ʼ P10/P40/P41 ڷʱ֮趨 ****************//
//----------------------------------------------------------------------//
	SYSTEM_INIT();		// IO, CGCR ʼ P10/P40/P41 ڷʱ֮趨
//----------------------------------------------------------------------//
	WDCDR.byte = 0x4e;				// clear wdt

//--------------------------------------------------------------------------------------------------//
//	Ҫ (ⲿپ or ⲿپ),  <OPmode.h> 趨£
//.....................................................................................
//#undef	XTAL_High		// ⲿپ: #define(ʹþ) / #undef(þ) :
//#undef	XTAL_Low		// ⲿپ: #define(ʹþ) / #undef(þ) :
//.....................................................................................
//	 <OPmode.h> ęnϳ
//	עļ֮ⲿл.
//--------------------------------------------------------------------------------------------------//




//*********************************************************************
// 			: Each Mode Switch Sequence
//	Normal1	:----------------------------------------------------------
//			: --> Normal1
//			: --> IDLE0(INTTBT release)		--> Normal1
//			: --> IDLE1(Interrupt release)	--> Normal1
//			: --> STOP (ȴ)			--> Normal1
//	Normal2	:----------------------------------------------------------
//			: --> Normal2
//			: --> IDLE2(ȴж)			--> Normal2
//			: --> STOP (ȴ)			--> Normal2
//	SLOW2	:----------------------------------------------------------
//			: --> SLOW2
//	SLOW1	:----------------------------------------------------------
//			: --> SLOW1
//			: --> SLEEP0(INTTBT release)	--> SLOW1
//			: --> SLEEP1(Interrupt release)	--> SLOW1
//			: --> STOP  (ȴ)			--> SLOW1
//	--------:----------------------------------------------------------
//*********************************************************************


//----------------------------------------//
//	˷ KWI5  STOP mode
	d_KWU_05_EnL;
//......|..| EnL/EnH/Dis: stop mode release level, or Disable
//......| 00~15: KWU00~KWU15

//----------------------------------------//
//****** Power on Ϊ Normal1 mode ******//
//----------------------------------------//

//	Normal1 entry stop mode ............
	__asm("CPL (_P7DR).0");
	Active_STOP;					// ˷ KWI5  STOP mode
	__asm("CPL (_P7DR).0");

//	Normal1 entry IDLE0 mode ............
	__asm("CPL (_P7DR).6");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_IDLE0;					// TGHALT: (Normal1->IDLE0) / (SLOW1->SLEEP0) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P7DR).6");

//	Normal1 entry IDLE1 mode ............
	__asm("CPL (_P9DR).1");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_IDLE1;					// IDLE: (Normal1->IDLE1) / (Normal2->IDLE2) / (SLOW1->SLEEP1) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P9DR).1");

//----------------------------------------//
//****** Entry Normal2 mode **************//
//----------------------------------------//
//	MQ6812 LIRC һϵΪ״̬
//	Ա change to Normal2 mode, ϵͳɲԤ reset
	OpMode_Change_to(iNor2);		// ѡҪĹģʽ (iNor1/iNor2/iSlow2/iSlow1) ֮һ

//	Normal2 entry stop mode ............
	__asm("CPL (_P7DR).0");
	Active_STOP;					// ˷ KWI5  STOP mode
	__asm("CPL (_P7DR).0");

//	Normal2 entry IDLE2 mode ............
	__asm("CPL (_P9DR).1");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_IDLE2;					// IDLE: (Normal1->IDLE1) / (Normal2->IDLE2) / (SLOW1->SLEEP1) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P9DR).1");

//----------------------------------------//
//****** Entry SLOW2 mode ****************//
//----------------------------------------//
	OpMode_Change_to(iSlow2);		// ѡҪĹģʽ (iNor1/iNor2/iSlow2/iSlow1) ֮һ

//----------------------------------------//
//****** Entry SLOW1 mode ****************//
//----------------------------------------//
	OpMode_Change_to(iSlow1);		// ѡҪĹģʽ (iNor1/iNor2/iSlow2/iSlow1) ֮һ

//	SLOW1 entry stop mode ............
	__asm("CPL (_P7DR).0");
	Active_STOP;					// ˷ KWI5  STOP mode
	__asm("CPL (_P7DR).0");

//	SLOW1 entry SLEEP0 mode ............
	__asm("CPL (_P7DR).6");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_SLEEP0;					// TGHALT: (Normal1->IDLE0) / (SLOW1->SLEEP0) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P7DR).6");

//	SLOW1 entry SLEEP1 mode ............
	__asm("CPL (_P9DR).1");
	INTTBT_Init_OP();				// initial TBT timer setting
									// ˷ TBT  IDLE1/IDLE2/SLEEP1 mode
	Active_SLEEP1;					// IDLE: (Normal1->IDLE1) / (Normal2->IDLE2) / (SLOW1->SLEEP1) mode
	Disable_INTTBT_OP();			// clear INTTBT setting after release IDLE0/SLEEP0 mode
	__asm("CPL (_P9DR).1");
//----------------------------------------//
//----------------------------------------//


	WDCDR.byte = 0x4e;				// clear wdt
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	while(1)
	{
		WDCDR.byte = 0x4e;			// clear wdt
		__asm("CPL (_P7DR).6");
		__asm("CPL (_P7DR).6");
		__asm("CPL (_P7DR).6");
		__asm("CPL (_P7DR).6");
	}
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

}


